local Autoload = true
				-- random text because curse management won't let you change a beta file to release, or upload the same file as release...

function PortalMetrics_OnLoad()
	PortalMetrics:RegisterEvent("ADDON_LOADED")
	PortalMetrics:RegisterEvent("CHAT_MSG_LOOT")
	PortalMetrics:RegisterEvent("PARTY_MEMBERS_CHANGED")
	PortalMetrics:RegisterEvent("RAID_TARGET_UPDATE")
	PortalMetrics:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
	PortalMetrics:RegisterEvent("CHAT_MSG_MONEY")
end

function PortalMetrics_OnMouseDown()
	PortalMetrics:StartMoving()
end

function PortalMetrics_OnMouseUp()
	PortalMetrics:StopMovingOrSizing()
end

function PortalMetrics_OnHide()
	Autoload=false
	PortalMetrics:Hide()
	print("PortalMetrics autoload disabled.  Use the /pm command to turn it back on.")
end


function PortalMetrics_OnEvent(self, event, ...)
	if event == "ADDON_LOADED" then
		if PortalMetrics_Data == nil then
			PortalMetrics_Data = {}
		end
	end
	if event == "CHAT_MSG_LOOT" then
		local msg = (select(1,...))
		local looter = strsplit(" ", msg)
		looter = strsplit("-", looter)
		local index = msg:find("Sentinax Beacon")
		if index == nil then
		else
			if PortalMetrics_IsInGroup(looter) > 0 then
				if PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(looter))] == nil then
					PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(looter))] = {
						["LOOTED"] = 1,
						["USED"] = 0
					}	
				else
					PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(looter))].LOOTED = PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(looter))].LOOTED + 1
				end
			end
			if Autoload then
				PortalMetrics:Show()
			end
		end
		UpdatePartyMembers()
	end
	if event == "PARTY_MEMBERS_CHANGED" or event == "RAID_TARGET_UPDATE" then
		UpdatePartyMembers()
	end
	if event == "CHAT_MSG_MONSTER_EMOTE" then
		local msg, name = select(1, ...)
		if msg == "%s has summoned demonic portals!" or msg == "%s has extended the duration of the demonic portals!" then
			if PortalMetrics_IsInGroup(name) > 0 then
				if PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(name))] == nil then
					PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(name))] = {
						["LOOTED"] = 0,
						["USED"] = 1
					}	
				else
					PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(name))].USED = PortalMetrics_Data[UnitGUID("party"..PortalMetrics_IsInGroup(name))].USED + 1
				end
				if Autoload then
					PortalMetrics:Show()
				end
			end
			
		end
		UpdatePartyMembers()
	end
	if event == "CHAT_MSG_MONEY" then
		PortalMetrics_Nethershards:SetText((select(2,GetCurrencyInfo(1226))))
	end
end

function UpdatePartyMembers()

	PortalMetrics_Player1:SetText("");
	PortalMetrics_Player2:SetText("");
	PortalMetrics_Player3:SetText("");
	PortalMetrics_Player4:SetText("");
	PortalMetrics_Player1Metric:SetText("");
	PortalMetrics_Player2Metric:SetText("");
	PortalMetrics_Player3Metric:SetText("");
	PortalMetrics_Player4Metric:SetText("");
	
	if GetNumGroupMembers() == 2 then
		PortalMetrics_Player1:SetText(UnitName("party1"));
		if PortalMetrics_Data[UnitGUID("party1")] == nil then
			PortalMetrics_Data[UnitGUID("party1")] = {
				["LOOTED"] = 0,
				["USED"] = 0
			}	
		end
		if PortalMetrics_Data[UnitGUID("party1")].LOOTED == 0 then
			PortalMetrics_Player1Metric:SetText("100%")
			PortalMetrics_Player1:SetTextColor(0, 1, 0)
			PortalMetrics_Player1Metric:SetTextColor(0, 1, 0)
		else
			local score = math.min(PortalMetrics_Data[UnitGUID("party1")].USED / PortalMetrics_Data[UnitGUID("party1")].LOOTED, 1)
			PortalMetrics_Player1Metric:SetText(round(score * 100, 0) .. "%")
			PortalMetrics_Player1:SetTextColor(1-score, score, 0)
			PortalMetrics_Player1Metric:SetTextColor(1-score, score, 0)
		end
	end
	if GetNumGroupMembers() == 3 then
		PortalMetrics_Player2:SetText(UnitName("party2"));
		if PortalMetrics_Data[UnitGUID("party2")] == nil then
			PortalMetrics_Data[UnitGUID("party2")] = {
				["LOOTED"] = 0,
				["USED"] = 0
			}	
		end
		if PortalMetrics_Data[UnitGUID("party2")].LOOTED == 0 then
			PortalMetrics_Player2Metric:SetText("100%")
			PortalMetrics_Player2:SetTextColor(0, 1, 0)
			PortalMetrics_Player2Metric:SetTextColor(0, 1, 0)
		else
			local score = math.min(PortalMetrics_Data[UnitGUID("party2")].USED / PortalMetrics_Data[UnitGUID("party2")].LOOTED, 1)
			PortalMetrics_Player2Metric:SetText(round(score * 100, 0) .. "%")
			PortalMetrics_Player2:SetTextColor(1-score, score, 0)
			PortalMetrics_Player2Metric:SetTextColor(1-score, score, 0)
		end
	end
	if GetNumGroupMembers() == 4 then
		PortalMetrics_Player3:SetText(UnitName("party3"));
		if PortalMetrics_Data[UnitGUID("party3")] == nil then
			PortalMetrics_Data[UnitGUID("party3")] = {
				["LOOTED"] = 0,
				["USED"] = 0
			}
		end
		if PortalMetrics_Data[UnitGUID("party3")].LOOTED == 0 then
			PortalMetrics_Player3Metric:SetText("100%")
			PortalMetrics_Player3:SetTextColor(0, 1, 0)
			PortalMetrics_Player3Metric:SetTextColor(0, 1, 0)
		else
			local score = math.min(PortalMetrics_Data[UnitGUID("party3")].USED / PortalMetrics_Data[UnitGUID("party3")].LOOTED, 1)
			PortalMetrics_Player3Metric:SetText(round(score * 100, 0) .. "%")
			PortalMetrics_Player3:SetTextColor(1-score, score, 0)
			PortalMetrics_Player3Metric:SetTextColor(1-score, score, 0)
		end
	end
	if GetNumGroupMembers() == 5 then
		PortalMetrics_Player4:SetText(UnitName("party4"));
		if PortalMetrics_Data[UnitGUID("party4")] == nil then
			PortalMetrics_Data[UnitGUID("party4")] = {
				["LOOTED"] = 0,
				["USED"] = 0
			}	
		end
		if PortalMetrics_Data[UnitGUID("party4")].LOOTED == 0 then
			PortalMetrics_Player4Metric:SetText("100%")
			PortalMetrics_Player4:SetTextColor(0, 1, 0)
			PortalMetrics_Player4Metric:SetTextColor(0, 1, 0)
		else
			local score = math.min(PortalMetrics_Data[UnitGUID("party4")].USED / PortalMetrics_Data[UnitGUID("party4")].LOOTED, 1)
			PortalMetrics_Player4Metric:SetText(round(score * 100, 0) .. "%")
			PortalMetrics_Player4:SetTextColor(1-score, score, 0)
			PortalMetrics_Player4Metric:SetTextColor(1-score, score, 0)
		end
	end
	
	PortalMetrics_Nethershards:SetText((select(2,GetCurrencyInfo(1226))))
end

function PortalMetrics_Report()
	if GetNumGroupMembers() < 2 then return end
	SendChatMessage("PortalMetrics Report - Beacon Utilization", "PARTY")
	SendChatMessage("Score  Name (Looted/Used)", "PARTY")
    for i = 1, GetNumGroupMembers()-1 do
		if PortalMetrics_Data[UnitGUID("party" .. i)] == nil then
			print("nil")
			PortalMetrics_Data[UnitGUID("party" .. i)] = {
				["LOOTED"] = 0,
				["USED"] = 0
			}	
		end	
		local score = 1
		if PortalMetrics_Data[UnitGUID("party" .. i)].LOOTED > 0 then 
			score = math.min(PortalMetrics_Data[UnitGUID("party" .. i)].USED / PortalMetrics_Data[UnitGUID("party" .. i)].LOOTED, 1)
		end
		local str = round(score * 100, 0) .. "%  " .. UnitName("party"..i) .. "  (" .. PortalMetrics_Data[UnitGUID("party" .. i)].LOOTED ..  "/" .. PortalMetrics_Data[UnitGUID("party" .. i)].USED .. ")";
		SendChatMessage(str, "PARTY")
    end
	SendChatMessage("Note: Don't forget, tanks have trouble using beacons!", "PARTY")
end

SLASH_PortalMetrics1 = "/pm"
SlashCmdList["PortalMetrics"] = function(msg)
	Autoload = true
	UpdatePartyMembers()
	PortalMetrics:Show()
end

function PortalMetrics_IsInGroup(name)
    for i = 1, GetNumGroupMembers() do
        if UnitName("party"..i) == name then
            return i
        end
    end
    return 0
end

function round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end
